/*
pot 2 est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus
de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
mme temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr */

#include "commun.h"
#include "console.h"


/* retourne une chaine de caractre pour l'idle (pas d'allocation */
static const char * print_idle(time_t idle_time)
{
  static char idle_char[10];

  /* pour Samba, xdm et erreur de lecture sur la tty */
  if (idle_time < 0)
    return (const char *) "???";
  
  /* juste secondes */
  if (idle_time < 60)
    {
      sprintf (idle_char, "%ds", (int) idle_time);
      return (const char *) idle_char;
    }
  
  /* juste minutes */
  if (idle_time < 60*60)
    {
      sprintf (idle_char, "%dm", (int) (idle_time/60));
      return (const char *) idle_char;
    }

  /* heure + minutes */
  if (idle_time < 60*60*24)
    {
      sprintf (idle_char, "%dh%02d",
	       (int) (idle_time / (60 * 60)),
	       (int) ((idle_time % (60 * 60)) / 60));
      return (const char *) idle_char;
    }
  
  /* jours seulement */
  if (idle_time < 60*60*24*10000)
    {
      sprintf (idle_char, "%dj",
	       (int) (idle_time / (60 * 60 * 24)));
      return (const char *) idle_char;
    }
  
  /* au cas ou il y aurait un grand concours d'idle ;-) */
  /* pas de "s"  ans pour des raisons de taille */
  return (const char *) ">27an"; 
}



void console ( char *chemin ,int couleur)
{
  int compteur;
  
  char talk;
  
  compteur = recherche_pots(chemin);

  /* initialisation de la structure */
  connecte = &depart;

  if ( compteur > 0 )
    {
      if ( couleur == 1 )
	printf("\033[30;42mLogin    Talk  Idle "
	       "\033[30;43m   Nom                   "
	       "\033[30;41m Salle             \033[0m\n");
      else
	printf("Login    Talk  Idle     Nom                   "
	       "Salle          \n");

      while ( (connecte = connecte->next) )
	{
	  /* peut-on talker la personne */
	  if ( connecte->talk == 2)
	    talk = 'w'; /* w comme Windows (samba) */
	  else if ( connecte->talk == 3)
	    talk = 'x'; /* x comme xdm (log graphique) */
	  else if ( connecte->talk == 1)
	    talk = '+';
	  else
	    talk = '-';
 
	  printf ("%-8.8s  %c   %5.5s  %-23.23s  %s\n",
		  connecte->login,
		  talk,
		  print_idle(connecte->idle),
		  connecte->nom,
		  connecte->salle );
	}
    }
  else
    {
      printf ("Pas de \"pot\" trouv.\n");
    }
}
